var MinigameHare = function() {
	// xx39
	var container;
	var callback;
	var difficulty;
	var started;
	var defSyringeOnTime = [1000, 1500, 2000];
	var defSyringeOffTime = [3000, 2500, 2000];
	var defAttackOnTime = [1250, 1750, 2500];
	var defAttackOffTime = [500, 1000, 2000];
	var defMosquitoManHP = [4, 6, 10];
	var defHareHP = [12, 12, 8];
	var signTimeouts = [null, null, null, null];
	var syringeOnTime;
	var syringeOffTime;
	var attackOnTime;
	var attackOffTime;
	var mmHP;
	var hHP;
	var mmHPMax;
	var hHPMax;
	var init = function(_container, _callback, _difficulty) {
		container = _container;
		callback = _callback;
		difficulty = _difficulty;
		started = false;
		signTimeouts = [null, null, null, null];
		syringeOnTime = defSyringeOnTime[difficulty];
		syringeOffTime = defSyringeOffTime[difficulty];
		attackOnTime = defAttackOnTime[difficulty];
		attackOffTime = defAttackOffTime[difficulty];
		mmHP = mmHPMax = defMosquitoManHP[difficulty];
		hHP = hHPMax = defHareHP[difficulty];
		container.html('<div style="position:relative;top:0px;left:0px;width:220px">' +
			'<img id="start" src="pic/nyul.jpg" style="position:absolute;top:0px;left:0px;z-index:1;cursor:pointer" onclick="MinigameHare.start()" />' +
			'<img id="sign0" src="pic/tu.gif" style="position:absolute;top:0px;left:0px;z-index:2;visibility:hidden;cursor:pointer" onclick="MinigameHare.hit(0)" />' +
			'<img id="sign1" src="pic/nyuljel.gif" style="position:absolute;top:0px;left:0px;z-index:2;visibility:hidden;cursor:pointer" onclick="MinigameHare.hit(1)" />' +
			'<img id="sign2" src="pic/nyuljel.gif" style="position:absolute;top:0px;left:0px;z-index:2;visibility:hidden;cursor:pointer" onclick="MinigameHare.hit(2)" />' +
			'<img id="sign3" src="pic/nyuljel.gif" style="position:absolute;top:0px;left:0px;z-index:2;visibility:hidden;cursor:pointer" onclick="MinigameHare.hit(3)" />' +
			'<div id="harehp" style="position:absolute;top:270px;left:0px;z-index:2;width:200px;height:20px;background-color:#bb2222">kattints</div>' +
			'<div id="mosquitomanhp" style="position:absolute;top:306px;left:0px;z-index:2;width:200px;height:20px;background-color:#22bb22">a képre!</div>' +
			'</div>' +
			'<div style="height: 330px">&nbsp;</div>');
	};
	var rnd = function(n) {
		return Math.floor(Math.random() * n);
	};
	var stop = function(index) {
		for (var i = 0; i < 4; i++) {
			if ((index == -1 || index == i) && signTimeouts[index] != null) {
				clearTimeout(signTimeouts[index]);
				signTimeouts[index] = null;
			}
		}
	};
	var setSign = function(index) {
		if (!started) return;
		stop(index);
		var img = $('#sign' + index);
		img.css('top', (0 + rnd(226)) + 'px');
		img.css('left', (0 + rnd(168)) + 'px');
		img.css('visibility', 'visible');
		signTimeouts[index] = setTimeout(function() { tick(index); }, (index == 0 ? syringeOnTime : attackOnTime));
	};
	var hideSign = function(index) {
		stop(index);
		var img = $('#sign' + index);
		img.css('visibility', 'hidden');
		signTimeouts[index] = setTimeout(function() { setSign(index); }, (index == 0 ? syringeOffTime : attackOffTime) + rnd(2000));
	};
	var hit = function(index) {
		if (!started) return;
		hideSign(index);
		if (index == 0) {
			hHP--; // hit
			showHP();
			if (hHP <= 0) {
				stop(-1);
				started = false;
				callback('PAGE', 'xx40'); // win
			}
		}
	};
	var tick = function(index) {
		hideSign(index);
		if (index > 0) {
			mmHP--; // wound
			showHP();
			if (mmHP <= 0) {
				stop(-1);
				started = false;
				callback('PAGE', 'xx122'); // fail
			}
		}
	};
	var showHP = function() {
		$('#harehp').css('width', Math.floor(200 * hHP / hHPMax) + 'px');
		$('#mosquitomanhp').css('width', Math.floor(200 * mmHP / mmHPMax) + 'px');
	}
	var start = function() {
		if (started) return;
		started = true;
		$('#start').css('cursor', 'default');
		$('#harehp').html('&nbsp;');
		$('#mosquitomanhp').html('&nbsp;');
		for (let i = 0; i < 4; i++) {
			signTimeouts[i] = setTimeout(function() { setSign(i) }, rnd(2000 + difficulty * 5000));
		}
		showHP();
	};
	return { init: init, start: start, hit: hit };
} ();

var MinigameDragon = function() {
	// xx87
	var container;
	var callback;
	var difficulty;
	var imageCache;
	var indices;
	var rnd = function(n) {
		return Math.floor(Math.random() * n);
	};
	var init = function(_container, _callback, _difficulty) {
		container = _container;
		callback = _callback;
		difficulty = _difficulty;
		imageCache = [];
		indices = [];
		var t;
		var s = '';
		indices[0] = 0; // movable
		for (var i = 0; i < 16; i++) {
			let img = new Image();
			img.src = 'pic/s' + i + '.jpg';
			imageCache[i] = img;
		}
		// draw board
		for (var i = 0; i < 4; i++) {
			for (var j = 0; j < 4; j++) {
				let index = i * 4 + j;
				s += '<img id="piece' + index + '" src="pic/s0.jpg" style="cursor:pointer; position:absolute; top:' + (77 * i + 0) + 'px; left:' + (77 * j + 0) + 'px; z-index:1" onclick="MinigameDragon.move(' + index + ')" />';
				if (difficulty > 0) {
					s += '<img src="pic/s' + index + '.jpg" style="position:absolute; top:' + (77 * i + 330) + 'px; left:' + (77 * j + 0) + 'px; z-index:1" />';
				}
			}
		}
		container.html('<div style="position:relative; top:0px; left:0px; margin:auto; width:320px">' +
			s +
			'</div>' +
			'<div style="height: ' + (difficulty == 0 ? 330 : 660) + 'px">&nbsp;</div>');
		// shuffle
		for (var i = 1; i < 16; i++) {
			do {
				t = rnd(15) + 1;
				if (indices.includes(t)) t = 0;
			} while (t == 0);
			indices[i] = t;
			setPiece(i);
		}
	};
	var setPiece = function(i) {
		$('#piece' + i).attr('src', imageCache[indices[i]].src);
	};
	var swap = function(i, j) {
		var temp = indices[i];
		indices[i] = indices[j];
		indices[j] = temp;
		setPiece(i);
		setPiece(j);
		for (i = 0; i < 16; i++) {
			if (indices[i] != i) {
				return;
			}
		}
		callback('PAGE', 'xx88');
	};
	var move = function(i) {
		if (indices[i] == 0) return;
		if (difficulty == 2) {
			for (var j = 0; j < 16; j++) {
				if (indices[j] == 0) {
					swap(i, j);
					return;
				}
			}
		}
		if (i > 0 && indices[i - 1] == 0 && (i % 4) != 0) {
			swap(i, i - 1); // left
			return;
		}
		if (i < 15 && indices[i + 1] == 0 && (i % 4) != 3) {
			swap(i, i + 1); // right
			return;
		}
		if (i > 3 && indices[i - 4] == 0) {
			swap(i, i - 4); // up
			return;
		}
		if (i < 12 && indices[i + 4] == 0) {
			swap(i, i + 4); // down
			return;
		}
	}
	return { init: init, move: move };
} ();
